//this file is part of aMule
//aMule Copyright (C)2003 aMule Team ( http://www.amule-project.net )
//This file Copyright (C)2003 Kry (elkry@sourceforge.net  http://www.amule-project.net )
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.#include <stdio.h>
#include "amule.h"

wxConnectionBase *MuleClient::OnMakeConnection()
{
    return new MuleConnection;
}

MuleConnection::MuleConnection()
            : wxConnection()
{
    theApp.conn = this;
}

MuleConnection::~MuleConnection()
{
    if (theApp.conn)
    {
        theApp.conn = NULL;
    }
}

wxChar* MuleConnection::OnRequest(const wxString & topic, const wxString & item, int *size, wxIPCFormat format) 
	{
		if (item == "STATS") {
			int filecount = theApp.downloadqueue->GetFileCount();
			// get the source count
			int stats[2];
			theApp.downloadqueue->GetDownloadStats(stats);
			static char buffer[1024];
			sprintf(buffer, "Statistics: \n Downloading files: %d\n Found sources: %d\n Active downloads: %d\n Active Uploads: %d\n Users on upload queue: %d", filecount, stats[0], stats[1], theApp.uploadqueue->GetUploadQueueLength(), theApp.uploadqueue->GetWaitingUserCount());
			return buffer;
		}

		if (item == "DL_QUEUE") {
			return (char *) theApp.amuledlg->transferwnd->downloadlistctrl->getTextList().GetData();
		}

		if (item == "UL_QUEUE") {
			static char buffer[1024];
			sprintf(buffer, "We should be showing UL list here");
			return buffer;
		}
		
		if (item == "CONNSTAT") {
					if (theApp.serverconnect->IsConnected()) {
						return("Connected");
					} else {
						return("Not Connected");
					}
		}

		if (item == "RECONN") {
					if (theApp.serverconnect->IsConnected()) {
						return("Already Connected");
					} else {
						theApp.serverconnect->ConnectToAnyServer();
						theApp.amuledlg->ShowConnectionState(false);
						return("Reconected");
					}
		}

		if (item == "DISCONN") {
					if (theApp.serverconnect->IsConnected()) {
						theApp.serverconnect->Disconnect();
						theApp.OnlineSig(); // Added By Bouc7
						return("Disconnected");
					} else {
						return("Already conected");
					}
		}
		
		
		if (item.Left(5).Cmp( "PAUSE")==0) { 
			if (item.Mid(5).IsNumber()) {
				int fileID=theApp.downloadqueue->GetFileCount() - atoi(item.Mid(5).GetData());
				if ((fileID >= 0) &&  (fileID < theApp.downloadqueue->GetFileCount())) {
					if (theApp.downloadqueue->GetFileByIndex(fileID)->IsPartFile()) {
							theApp.downloadqueue->GetFileByIndex(fileID)->PauseFile();
							printf("Paused\n");
							return((char *) theApp.amuledlg->transferwnd->downloadlistctrl->getTextList().GetData());
					} else return("Not part file");
				} else return("Out of range");
			} else return("Not a number");
		} 
		
		if (item.Left(6).Cmp( "RESUME")==0) { 
			if (item.Mid(6).IsNumber()) {
				int fileID2 =theApp.downloadqueue->GetFileCount() - atoi(item.Mid(6).GetData());
				if ((fileID2 >= 0) && (fileID2 < theApp.downloadqueue->GetFileCount())) {
					if (theApp.downloadqueue->GetFileByIndex(fileID2)->IsPartFile()) {
							theApp.downloadqueue->GetFileByIndex(fileID2)->ResumeFile();
							theApp.downloadqueue->GetFileByIndex(fileID2)->SavePartFile();
							printf("Resumed\n");
							return((char *) theApp.amuledlg->transferwnd->downloadlistctrl->getTextList().GetData());
					} else return("Not part file");
				} else return("Out of range");				
			} else return("Not a number");
		} 
		
		return "";
	}

wxConnectionBase * MuleServer::OnAcceptConnection(const wxString & topic) {
	if (theApp.glob_prefs->AcceptExternalConnections()==true) {
		if (topic==(wxString::Format("aMulecmd IPC %s", theApp.glob_prefs->ECPassword().GetData()))) {
			printf("Accepted Connection from amulecmd\n"); 
			return new MuleConnection; 
		}
		if (topic=="aMule IPC") {
			printf("Detected aMule IPC server\n"); 
			return new MuleConnection; 
		}
	} 
	printf("Incoming External Connection refused (Wrong Password, Wrong Topic or External Connections Disabled)\n");
    return NULL;	
}
